#include <bits/stdc++.h>
#include <bits/extc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;
using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;

void solve();

int main() {
#ifdef DEBUG
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(22);

    ll t;
    cin >> t;
    while (t--)
        solve();
}

ll sqrti(ll x) {
    ll L = 0, R = 1e9 + 10;
    while (R - L > 1) {
        ll M = (L + R) / 2;
        (M * M > x ? R : L) = M;
    }
    return L;
}

#define BAIL(...) { \
  cout << (__VA_ARGS__) << endl; \
  return; \
}void(0)

void solve() {
    ll a, b, k, m;
    cin >> a >> b >> k >> m;

    ll d = k * k - 4 * (-k + m - 1);
    ll dst = sqrti(d);
    if (dst * dst != d) BAIL(-1);
    if ((k + dst) % 2 != 0) BAIL(-1);
    vi xs = {(k - dst) / 2, (k + dst) / 2};
    vi ys;
    for (auto &x: xs) {
        ys.emplace_back(k - x);
    }

    ll best_x = -1, best_y = -1;

    for (int i = 0; i < xs.size(); ++i) {
        ll &x = xs[i];
        ll &y = ys[i];
        if (x < 0 || y < 0) continue;
        if (x > y) swap(x, y);
        ll swapcount = 0;
        for (ll j = 0; j < 2; ++j) {
            if (x > a - 1 || y > b - 1) {
                swapcount += 1;
                swap(x, y);
            }
        }
        if (swapcount > 1) continue;
        if (x < best_x || best_x == -1) best_x = x, best_y = y;
    }

    if (best_x == -1) BAIL(-1);
    cout << best_x << ' ' << best_y << endl;
}